<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SpaceFighter2020: src/CollisionVisitor.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SpaceFighter2020
   </div>
   <div id="projectbrief">This documentation reffers to the game Space Fighter 2020 created for pa2 course. Game is side-scrolling shooter where the goal is to get on the end of the level and kill as much as enemy ships as possible. Player can pick up bonuses for repairing point of health or upgrading his weapons.</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">CollisionVisitor.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="CollisionVisitor_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef CollisionVisitor_H</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define CollisionVisitor_H</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160; </div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="Player_8h.html">Player.h</a>&quot;</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="Enemy_8h.html">Enemy.h</a>&quot;</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="Projectile_8h.html">Projectile.h</a>&quot;</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="Bonus_8h.html">Bonus.h</a>&quot;</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="keyword">class </span><a class="code" href="classPlayer.html">Player</a>;</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="keyword">class </span><a class="code" href="classEnemy.html">Enemy</a>;</div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="keyword">class </span><a class="code" href="classProjectile.html">Projectile</a>;</div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="keyword">class </span><a class="code" href="classBonus.html">Bonus</a>;</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160; </div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160; </div>
<div class="line"><a name="l00018"></a><span class="lineno"><a class="line" href="classCollisionVisitor.html">   18</a></span>&#160;<span class="keyword">class </span><a class="code" href="classCollisionVisitor.html">CollisionVisitor</a>{</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classCollisionVisitor.html#af05d93df91ad1b3b7fbf939cbb8f2c28">VisitEnemy</a>(<a class="code" href="classEnemy.html">Enemy</a> * enemy) = 0;</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160; </div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classCollisionVisitor.html#a0fb0fccfcfe6bf348588a406b3e26407">VisitProjectile</a>(<a class="code" href="classProjectile.html">Projectile</a> * projectile) = 0;</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160; </div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classCollisionVisitor.html#a27165ce473133803b0cf2e7343686876">VisitPlayer</a>(<a class="code" href="classPlayer.html">Player</a> * player) = 0;</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160; </div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classCollisionVisitor.html#ac21e99081aed7153372f3aa3b72e7cf5">VisitBonus</a>(<a class="code" href="classBonus.html">Bonus</a> * bonus) = 0;</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;};</div>
<div class="line"><a name="l00048"></a><span class="lineno"><a class="line" href="classCollisionPlayer.html">   48</a></span>&#160;<span class="keyword">class </span><a class="code" href="classCollisionPlayer.html">CollisionPlayer</a>: <span class="keyword">public</span> <a class="code" href="classCollisionVisitor.html">CollisionVisitor</a>{</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00054"></a><span class="lineno"><a class="line" href="classCollisionPlayer.html#a21792204e1d7ecb150393cb140a13115">   54</a></span>&#160;    <a class="code" href="classCollisionPlayer.html#a21792204e1d7ecb150393cb140a13115">CollisionPlayer</a> (<a class="code" href="classPlayer.html">Player</a> * player) : <a class="code" href="classCollisionPlayer.html#abfe61838d4089df057acff360f435aa8">m_Player</a>{player}{}</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160; </div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classCollisionPlayer.html#a6c7b72ba0659a5af4ea831f467303e45">VisitEnemy</a>(<a class="code" href="classEnemy.html">Enemy</a> * enemy) <span class="keyword">override</span>;</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classCollisionPlayer.html#a83723cb8c1478311edfb8ae22bdbe049">VisitProjectile</a>(<a class="code" href="classProjectile.html">Projectile</a> * projectile) <span class="keyword">override</span>;</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classCollisionPlayer.html#ae8bc585e6957a6d630394bf1dedb9ac7">VisitPlayer</a>(<a class="code" href="classPlayer.html">Player</a> * player) <span class="keyword">override</span>;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classCollisionPlayer.html#a70532d8dd3460944d7c09294337333a5">VisitBonus</a>(<a class="code" href="classBonus.html">Bonus</a> * bonus) <span class="keyword">override</span>;</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    <span class="keyword">private</span>:</div>
<div class="line"><a name="l00061"></a><span class="lineno"><a class="line" href="classCollisionPlayer.html#abfe61838d4089df057acff360f435aa8">   61</a></span>&#160;    <a class="code" href="classPlayer.html">Player</a> * <a class="code" href="classCollisionPlayer.html#abfe61838d4089df057acff360f435aa8">m_Player</a> = <span class="keyword">nullptr</span>;</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;};</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160; </div>
<div class="line"><a name="l00068"></a><span class="lineno"><a class="line" href="classCollisionEnemy.html">   68</a></span>&#160;<span class="keyword">class </span><a class="code" href="classCollisionEnemy.html">CollisionEnemy</a>: <span class="keyword">public</span> <a class="code" href="classCollisionVisitor.html">CollisionVisitor</a>{</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00074"></a><span class="lineno"><a class="line" href="classCollisionEnemy.html#a8529842d57050bbb34798d9406825f4b">   74</a></span>&#160;    <a class="code" href="classCollisionEnemy.html#a8529842d57050bbb34798d9406825f4b">CollisionEnemy</a> (<a class="code" href="classEnemy.html">Enemy</a> * enemy) : <a class="code" href="classCollisionEnemy.html#af911826d10cff7927adcd66d46e92609">m_Enemy</a>{enemy}{}</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160; </div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classCollisionEnemy.html#ad8f7122e1d2ecc35b1314a6b8914086a">VisitEnemy</a>(<a class="code" href="classEnemy.html">Enemy</a> * enemy) <span class="keyword">override</span>;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classCollisionEnemy.html#ae88d05c50d4cdb6e408d399b6bfa33ec">VisitProjectile</a>(<a class="code" href="classProjectile.html">Projectile</a> * projectile) <span class="keyword">override</span>;</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classCollisionEnemy.html#a69f0406eb5baf03d312a34b7ca810954">VisitPlayer</a>(<a class="code" href="classPlayer.html">Player</a> * player) <span class="keyword">override</span>;</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classCollisionEnemy.html#a47e1ae390eb0ad1724e2f2c9ef22f850">VisitBonus</a>(<a class="code" href="classBonus.html">Bonus</a> * bonus) <span class="keyword">override</span>;</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    <span class="keyword">private</span>:</div>
<div class="line"><a name="l00081"></a><span class="lineno"><a class="line" href="classCollisionEnemy.html#af911826d10cff7927adcd66d46e92609">   81</a></span>&#160;    <a class="code" href="classEnemy.html">Enemy</a> * <a class="code" href="classCollisionEnemy.html#af911826d10cff7927adcd66d46e92609">m_Enemy</a> = <span class="keyword">nullptr</span>;</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;};</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160; </div>
<div class="line"><a name="l00088"></a><span class="lineno"><a class="line" href="classCollisionBonus.html">   88</a></span>&#160;<span class="keyword">class </span><a class="code" href="classCollisionBonus.html">CollisionBonus</a>: <span class="keyword">public</span> <a class="code" href="classCollisionVisitor.html">CollisionVisitor</a>{</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00094"></a><span class="lineno"><a class="line" href="classCollisionBonus.html#ad49b207ae84e9f714dc64e1e11a8b8e6">   94</a></span>&#160;    <a class="code" href="classCollisionBonus.html#ad49b207ae84e9f714dc64e1e11a8b8e6">CollisionBonus</a> (<a class="code" href="classBonus.html">Bonus</a> * bonus) : <a class="code" href="classCollisionBonus.html#a6635fa7d9cad4ed70228b74c7129dcd6">m_Bonus</a>{bonus}{}</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160; </div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classCollisionBonus.html#aff73cb5263fadec07b617171936ce3f2">VisitEnemy</a>(<a class="code" href="classEnemy.html">Enemy</a> * enemy) <span class="keyword">override</span>;</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classCollisionBonus.html#aea3256a97e9b80d02a0c1234d47694e1">VisitProjectile</a>(<a class="code" href="classProjectile.html">Projectile</a> * projectile) <span class="keyword">override</span>;</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classCollisionBonus.html#a465bb52368516d6ebf0db27aa1096f1b">VisitPlayer</a>(<a class="code" href="classPlayer.html">Player</a> * player) <span class="keyword">override</span>;</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classCollisionBonus.html#a3deb7dbb790606457edd73a4443d1001">VisitBonus</a>(<a class="code" href="classBonus.html">Bonus</a> * bonus) <span class="keyword">override</span>;</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    <span class="keyword">private</span>:</div>
<div class="line"><a name="l00101"></a><span class="lineno"><a class="line" href="classCollisionBonus.html#a6635fa7d9cad4ed70228b74c7129dcd6">  101</a></span>&#160;    <a class="code" href="classBonus.html">Bonus</a> * <a class="code" href="classCollisionBonus.html#a6635fa7d9cad4ed70228b74c7129dcd6">m_Bonus</a> = <span class="keyword">nullptr</span>;</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;};</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160; </div>
<div class="line"><a name="l00108"></a><span class="lineno"><a class="line" href="classCollisionProjectile.html">  108</a></span>&#160;<span class="keyword">class </span><a class="code" href="classCollisionProjectile.html">CollisionProjectile</a>: <span class="keyword">public</span> <a class="code" href="classCollisionVisitor.html">CollisionVisitor</a>{</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00114"></a><span class="lineno"><a class="line" href="classCollisionProjectile.html#a39ab03f27b2c6f08565782b77f7f821e">  114</a></span>&#160;    <a class="code" href="classCollisionProjectile.html#a39ab03f27b2c6f08565782b77f7f821e">CollisionProjectile</a> (<a class="code" href="classProjectile.html">Projectile</a> * projectile) : <a class="code" href="classCollisionProjectile.html#abcd2cee16703c446d6949b8ee3608ef0">m_Projectile</a>{projectile}{}</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160; </div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classCollisionProjectile.html#ac5a5da223a772354ef805e2f01be36f4">VisitEnemy</a>(<a class="code" href="classEnemy.html">Enemy</a> * enemy) <span class="keyword">override</span>;</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classCollisionProjectile.html#a3ecf64b1d68b549f1a478f55f6e84c54">VisitProjectile</a>(<a class="code" href="classProjectile.html">Projectile</a> * projectile) <span class="keyword">override</span>;</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classCollisionProjectile.html#aed4abf7c92949c10b44799bf540e5416">VisitPlayer</a>(<a class="code" href="classPlayer.html">Player</a> * player) <span class="keyword">override</span>;</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classCollisionProjectile.html#a8ae39a9c7b38ab8d4e0965f80bda128d">VisitBonus</a>(<a class="code" href="classBonus.html">Bonus</a> * bonus) <span class="keyword">override</span>;</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    <span class="keyword">private</span>:</div>
<div class="line"><a name="l00121"></a><span class="lineno"><a class="line" href="classCollisionProjectile.html#abcd2cee16703c446d6949b8ee3608ef0">  121</a></span>&#160;    <a class="code" href="classProjectile.html">Projectile</a> * <a class="code" href="classCollisionProjectile.html#abcd2cee16703c446d6949b8ee3608ef0">m_Projectile</a> = <span class="keyword">nullptr</span>;</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;};</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160; </div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* CollisionVisitor_H */</span><span class="preprocessor"></span></div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclassCollisionVisitor_html_ac21e99081aed7153372f3aa3b72e7cf5"><div class="ttname"><a href="classCollisionVisitor.html#ac21e99081aed7153372f3aa3b72e7cf5">CollisionVisitor::VisitBonus</a></div><div class="ttdeci">virtual void VisitBonus(Bonus *bonus)=0</div><div class="ttdoc">Gets Bonus pointer from visiting object.</div></div>
<div class="ttc" id="aclassCollisionBonus_html"><div class="ttname"><a href="classCollisionBonus.html">CollisionBonus</a></div><div class="ttdoc">Resolves collision between Bonus and other objects.</div><div class="ttdef"><b>Definition:</b> CollisionVisitor.h:88</div></div>
<div class="ttc" id="aPlayer_8h_html"><div class="ttname"><a href="Player_8h.html">Player.h</a></div></div>
<div class="ttc" id="aclassCollisionProjectile_html_a8ae39a9c7b38ab8d4e0965f80bda128d"><div class="ttname"><a href="classCollisionProjectile.html#a8ae39a9c7b38ab8d4e0965f80bda128d">CollisionProjectile::VisitBonus</a></div><div class="ttdeci">void VisitBonus(Bonus *bonus) override</div><div class="ttdoc">Gets Bonus pointer from visiting object.</div><div class="ttdef"><b>Definition:</b> CollisionVisitor.cpp:79</div></div>
<div class="ttc" id="aclassCollisionBonus_html_aff73cb5263fadec07b617171936ce3f2"><div class="ttname"><a href="classCollisionBonus.html#aff73cb5263fadec07b617171936ce3f2">CollisionBonus::VisitEnemy</a></div><div class="ttdeci">void VisitEnemy(Enemy *enemy) override</div><div class="ttdoc">Gets Enemy pointer from visiting object.</div><div class="ttdef"><b>Definition:</b> CollisionVisitor.cpp:46</div></div>
<div class="ttc" id="aclassCollisionEnemy_html_a8529842d57050bbb34798d9406825f4b"><div class="ttname"><a href="classCollisionEnemy.html#a8529842d57050bbb34798d9406825f4b">CollisionEnemy::CollisionEnemy</a></div><div class="ttdeci">CollisionEnemy(Enemy *enemy)</div><div class="ttdoc">Construct a new Collision Enemy object with Enemy pointer.</div><div class="ttdef"><b>Definition:</b> CollisionVisitor.h:74</div></div>
<div class="ttc" id="aclassCollisionEnemy_html_ae88d05c50d4cdb6e408d399b6bfa33ec"><div class="ttname"><a href="classCollisionEnemy.html#ae88d05c50d4cdb6e408d399b6bfa33ec">CollisionEnemy::VisitProjectile</a></div><div class="ttdeci">void VisitProjectile(Projectile *projectile) override</div><div class="ttdoc">Gets Projectile pointer from visiting object.</div><div class="ttdef"><b>Definition:</b> CollisionVisitor.cpp:29</div></div>
<div class="ttc" id="aclassCollisionPlayer_html_ae8bc585e6957a6d630394bf1dedb9ac7"><div class="ttname"><a href="classCollisionPlayer.html#ae8bc585e6957a6d630394bf1dedb9ac7">CollisionPlayer::VisitPlayer</a></div><div class="ttdeci">void VisitPlayer(Player *player) override</div><div class="ttdoc">Gets Player pointer from visiting object.</div><div class="ttdef"><b>Definition:</b> CollisionVisitor.cpp:20</div></div>
<div class="ttc" id="aclassCollisionBonus_html_aea3256a97e9b80d02a0c1234d47694e1"><div class="ttname"><a href="classCollisionBonus.html#aea3256a97e9b80d02a0c1234d47694e1">CollisionBonus::VisitProjectile</a></div><div class="ttdeci">void VisitProjectile(Projectile *projectile) override</div><div class="ttdoc">Gets Projectile pointer from visiting object.</div><div class="ttdef"><b>Definition:</b> CollisionVisitor.cpp:48</div></div>
<div class="ttc" id="aclassCollisionPlayer_html_abfe61838d4089df057acff360f435aa8"><div class="ttname"><a href="classCollisionPlayer.html#abfe61838d4089df057acff360f435aa8">CollisionPlayer::m_Player</a></div><div class="ttdeci">Player * m_Player</div><div class="ttdef"><b>Definition:</b> CollisionVisitor.h:61</div></div>
<div class="ttc" id="aclassCollisionEnemy_html_a69f0406eb5baf03d312a34b7ca810954"><div class="ttname"><a href="classCollisionEnemy.html#a69f0406eb5baf03d312a34b7ca810954">CollisionEnemy::VisitPlayer</a></div><div class="ttdeci">void VisitPlayer(Player *player) override</div><div class="ttdoc">Gets Player pointer from visiting object.</div><div class="ttdef"><b>Definition:</b> CollisionVisitor.cpp:36</div></div>
<div class="ttc" id="aclassBonus_html"><div class="ttname"><a href="classBonus.html">Bonus</a></div><div class="ttdoc">Abstract class representing bonuses that can be applied to Player.</div><div class="ttdef"><b>Definition:</b> Bonus.h:12</div></div>
<div class="ttc" id="aclassCollisionEnemy_html"><div class="ttname"><a href="classCollisionEnemy.html">CollisionEnemy</a></div><div class="ttdoc">Resolves collision between Enemy and other objects.</div><div class="ttdef"><b>Definition:</b> CollisionVisitor.h:68</div></div>
<div class="ttc" id="aclassCollisionBonus_html_ad49b207ae84e9f714dc64e1e11a8b8e6"><div class="ttname"><a href="classCollisionBonus.html#ad49b207ae84e9f714dc64e1e11a8b8e6">CollisionBonus::CollisionBonus</a></div><div class="ttdeci">CollisionBonus(Bonus *bonus)</div><div class="ttdoc">Construct a new Collision Bonus object with Bonus pointer.</div><div class="ttdef"><b>Definition:</b> CollisionVisitor.h:94</div></div>
<div class="ttc" id="aclassCollisionProjectile_html_a39ab03f27b2c6f08565782b77f7f821e"><div class="ttname"><a href="classCollisionProjectile.html#a39ab03f27b2c6f08565782b77f7f821e">CollisionProjectile::CollisionProjectile</a></div><div class="ttdeci">CollisionProjectile(Projectile *projectile)</div><div class="ttdoc">Construct a new Collision Projectile object with Projectile pointer.</div><div class="ttdef"><b>Definition:</b> CollisionVisitor.h:114</div></div>
<div class="ttc" id="aclassCollisionPlayer_html_a21792204e1d7ecb150393cb140a13115"><div class="ttname"><a href="classCollisionPlayer.html#a21792204e1d7ecb150393cb140a13115">CollisionPlayer::CollisionPlayer</a></div><div class="ttdeci">CollisionPlayer(Player *player)</div><div class="ttdoc">Construct a new Collision Player object with Player pointer.</div><div class="ttdef"><b>Definition:</b> CollisionVisitor.h:54</div></div>
<div class="ttc" id="aEnemy_8h_html"><div class="ttname"><a href="Enemy_8h.html">Enemy.h</a></div></div>
<div class="ttc" id="aclassCollisionPlayer_html"><div class="ttname"><a href="classCollisionPlayer.html">CollisionPlayer</a></div><div class="ttdoc">Resolves collision between Player and other objects.</div><div class="ttdef"><b>Definition:</b> CollisionVisitor.h:48</div></div>
<div class="ttc" id="aProjectile_8h_html"><div class="ttname"><a href="Projectile_8h.html">Projectile.h</a></div></div>
<div class="ttc" id="aclassCollisionPlayer_html_a83723cb8c1478311edfb8ae22bdbe049"><div class="ttname"><a href="classCollisionPlayer.html#a83723cb8c1478311edfb8ae22bdbe049">CollisionPlayer::VisitProjectile</a></div><div class="ttdeci">void VisitProjectile(Projectile *projectile) override</div><div class="ttdoc">Gets Projectile pointer from visiting object.</div><div class="ttdef"><b>Definition:</b> CollisionVisitor.cpp:12</div></div>
<div class="ttc" id="aclassProjectile_html"><div class="ttname"><a href="classProjectile.html">Projectile</a></div><div class="ttdoc">class representing projectiles with their own speed, damage and sprites</div><div class="ttdef"><b>Definition:</b> Projectile.h:12</div></div>
<div class="ttc" id="aclassCollisionProjectile_html_aed4abf7c92949c10b44799bf540e5416"><div class="ttname"><a href="classCollisionProjectile.html#aed4abf7c92949c10b44799bf540e5416">CollisionProjectile::VisitPlayer</a></div><div class="ttdeci">void VisitPlayer(Player *player) override</div><div class="ttdoc">Gets Player pointer from visiting object.</div><div class="ttdef"><b>Definition:</b> CollisionVisitor.cpp:72</div></div>
<div class="ttc" id="aclassCollisionProjectile_html"><div class="ttname"><a href="classCollisionProjectile.html">CollisionProjectile</a></div><div class="ttdoc">Resolves collision between Projectile and other objects.</div><div class="ttdef"><b>Definition:</b> CollisionVisitor.h:108</div></div>
<div class="ttc" id="aclassCollisionVisitor_html_a0fb0fccfcfe6bf348588a406b3e26407"><div class="ttname"><a href="classCollisionVisitor.html#a0fb0fccfcfe6bf348588a406b3e26407">CollisionVisitor::VisitProjectile</a></div><div class="ttdeci">virtual void VisitProjectile(Projectile *projectile)=0</div><div class="ttdoc">Gets Projectile pointer from visiting object.</div></div>
<div class="ttc" id="aclassCollisionEnemy_html_a47e1ae390eb0ad1724e2f2c9ef22f850"><div class="ttname"><a href="classCollisionEnemy.html#a47e1ae390eb0ad1724e2f2c9ef22f850">CollisionEnemy::VisitBonus</a></div><div class="ttdeci">void VisitBonus(Bonus *bonus) override</div><div class="ttdoc">Gets Bonus pointer from visiting object.</div><div class="ttdef"><b>Definition:</b> CollisionVisitor.cpp:44</div></div>
<div class="ttc" id="aBonus_8h_html"><div class="ttname"><a href="Bonus_8h.html">Bonus.h</a></div></div>
<div class="ttc" id="aclassCollisionEnemy_html_af911826d10cff7927adcd66d46e92609"><div class="ttname"><a href="classCollisionEnemy.html#af911826d10cff7927adcd66d46e92609">CollisionEnemy::m_Enemy</a></div><div class="ttdeci">Enemy * m_Enemy</div><div class="ttdef"><b>Definition:</b> CollisionVisitor.h:81</div></div>
<div class="ttc" id="aclassEnemy_html"><div class="ttname"><a href="classEnemy.html">Enemy</a></div><div class="ttdoc">Represents enemy, it shoots diferent type of projectiles and has chance to drop bonus on death.</div><div class="ttdef"><b>Definition:</b> Enemy.h:15</div></div>
<div class="ttc" id="aclassCollisionBonus_html_a465bb52368516d6ebf0db27aa1096f1b"><div class="ttname"><a href="classCollisionBonus.html#a465bb52368516d6ebf0db27aa1096f1b">CollisionBonus::VisitPlayer</a></div><div class="ttdeci">void VisitPlayer(Player *player) override</div><div class="ttdoc">Gets Player pointer from visiting object.</div><div class="ttdef"><b>Definition:</b> CollisionVisitor.cpp:50</div></div>
<div class="ttc" id="aclassCollisionProjectile_html_ac5a5da223a772354ef805e2f01be36f4"><div class="ttname"><a href="classCollisionProjectile.html#ac5a5da223a772354ef805e2f01be36f4">CollisionProjectile::VisitEnemy</a></div><div class="ttdeci">void VisitEnemy(Enemy *enemy) override</div><div class="ttdoc">Gets Enemy pointer from visiting object.</div><div class="ttdef"><b>Definition:</b> CollisionVisitor.cpp:57</div></div>
<div class="ttc" id="aclassCollisionBonus_html_a3deb7dbb790606457edd73a4443d1001"><div class="ttname"><a href="classCollisionBonus.html#a3deb7dbb790606457edd73a4443d1001">CollisionBonus::VisitBonus</a></div><div class="ttdeci">void VisitBonus(Bonus *bonus) override</div><div class="ttdoc">Gets Bonus pointer from visiting object.</div><div class="ttdef"><b>Definition:</b> CollisionVisitor.cpp:55</div></div>
<div class="ttc" id="aclassCollisionProjectile_html_abcd2cee16703c446d6949b8ee3608ef0"><div class="ttname"><a href="classCollisionProjectile.html#abcd2cee16703c446d6949b8ee3608ef0">CollisionProjectile::m_Projectile</a></div><div class="ttdeci">Projectile * m_Projectile</div><div class="ttdef"><b>Definition:</b> CollisionVisitor.h:121</div></div>
<div class="ttc" id="aclassCollisionVisitor_html_af05d93df91ad1b3b7fbf939cbb8f2c28"><div class="ttname"><a href="classCollisionVisitor.html#af05d93df91ad1b3b7fbf939cbb8f2c28">CollisionVisitor::VisitEnemy</a></div><div class="ttdeci">virtual void VisitEnemy(Enemy *enemy)=0</div><div class="ttdoc">Gets Enemy pointer from visiting object.</div></div>
<div class="ttc" id="aclassCollisionVisitor_html_a27165ce473133803b0cf2e7343686876"><div class="ttname"><a href="classCollisionVisitor.html#a27165ce473133803b0cf2e7343686876">CollisionVisitor::VisitPlayer</a></div><div class="ttdeci">virtual void VisitPlayer(Player *player)=0</div><div class="ttdoc">Gets Player pointer from visiting object.</div></div>
<div class="ttc" id="aclassCollisionPlayer_html_a70532d8dd3460944d7c09294337333a5"><div class="ttname"><a href="classCollisionPlayer.html#a70532d8dd3460944d7c09294337333a5">CollisionPlayer::VisitBonus</a></div><div class="ttdeci">void VisitBonus(Bonus *bonus) override</div><div class="ttdoc">Gets Bonus pointer from visiting object.</div><div class="ttdef"><b>Definition:</b> CollisionVisitor.cpp:22</div></div>
<div class="ttc" id="aclassCollisionEnemy_html_ad8f7122e1d2ecc35b1314a6b8914086a"><div class="ttname"><a href="classCollisionEnemy.html#ad8f7122e1d2ecc35b1314a6b8914086a">CollisionEnemy::VisitEnemy</a></div><div class="ttdeci">void VisitEnemy(Enemy *enemy) override</div><div class="ttdoc">Gets Enemy pointer from visiting object.</div><div class="ttdef"><b>Definition:</b> CollisionVisitor.cpp:27</div></div>
<div class="ttc" id="aclassPlayer_html"><div class="ttname"><a href="classPlayer.html">Player</a></div><div class="ttdoc">Represent player, takes user input.</div><div class="ttdef"><b>Definition:</b> Player.h:14</div></div>
<div class="ttc" id="aclassCollisionBonus_html_a6635fa7d9cad4ed70228b74c7129dcd6"><div class="ttname"><a href="classCollisionBonus.html#a6635fa7d9cad4ed70228b74c7129dcd6">CollisionBonus::m_Bonus</a></div><div class="ttdeci">Bonus * m_Bonus</div><div class="ttdef"><b>Definition:</b> CollisionVisitor.h:101</div></div>
<div class="ttc" id="aclassCollisionPlayer_html_a6c7b72ba0659a5af4ea831f467303e45"><div class="ttname"><a href="classCollisionPlayer.html#a6c7b72ba0659a5af4ea831f467303e45">CollisionPlayer::VisitEnemy</a></div><div class="ttdeci">void VisitEnemy(Enemy *enemy) override</div><div class="ttdoc">Gets Enemy pointer from visiting object.</div><div class="ttdef"><b>Definition:</b> CollisionVisitor.cpp:4</div></div>
<div class="ttc" id="aclassCollisionVisitor_html"><div class="ttname"><a href="classCollisionVisitor.html">CollisionVisitor</a></div><div class="ttdoc">Abstract class of double dispatch visitor design patter.</div><div class="ttdef"><b>Definition:</b> CollisionVisitor.h:18</div></div>
<div class="ttc" id="aclassCollisionProjectile_html_a3ecf64b1d68b549f1a478f55f6e84c54"><div class="ttname"><a href="classCollisionProjectile.html#a3ecf64b1d68b549f1a478f55f6e84c54">CollisionProjectile::VisitProjectile</a></div><div class="ttdeci">void VisitProjectile(Projectile *projectile) override</div><div class="ttdoc">Gets Projectile pointer from visiting object.</div><div class="ttdef"><b>Definition:</b> CollisionVisitor.cpp:64</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
